/*
    Sehr oft liegen Daten im verbreiteten Excel Format vor.
    Zum Lesen und Schreiben dieses Formates existiert ein
    spezieller Satz von Befehlen:
    xlsReadM(file, range, sheet, vls);
    xlsReadSA(file, range, sheet, vls);
    xlsWrite(data, file, range, sheet, vls);
    xlsWriteM(data, file, range, sheet, vls);
    xlsWriteSA(data, file, range, sheet, vls);
    
    Eine detaillierte Beschreibung der funktionalitt finden Sie 
    in der Datei xls.src aus ihrem GAUSS SRC - Verzeichnis
*/

/* mit systate() kann man ermitteln, wo sich das GAUSS.EXE File befindet*/
path = sysstate(2,0)$+"examples\\";
file = path$+"Example_XLS.xls";

/*
    mat = xlsreadm(datei, bereich, tabelle, vls);
datei   - Name der zu lesenden .xls Datei
bereich - Zu importierender Bereich, z.B. "a2:b20" oder Startpunkt z.B. "a2"
tabelle - Nummer der Tabelle, aus der die Daten stammen
vls     - Spezieller String zur beschreibung der Umwandlung von fehlenden Werten
          oder Sonderformaten
*/

/*
    Zunchst lesen wir alle Daten aus der ersten Tabelle
*/
data1 = xlsreadm(file, "A2", 1, "");

/*
    die dabei importierte Spalte 3 enthlt aber Text Daten.
    Diese sollte man mit einem anderen Befehl laden.
    Um einen Teilbereich zu laden, kann anstelle der Startzelle
    auch ein Zellbereich angegeben werden.
    Zuerst setzt man also den Bereich zusammen,
    der fr das Lesen der Spalte C bentigt wird*/
x = 0 $+ "C" $+ ftocv(rows(data1),1,0); 
/*  Dann wird dieser Bereich geladen */
month = xlsreadsa(file, "C2:"$+x, 1, "");

/*  Durch nderungen des dritten Parameters in xlsreadm kann
    eine andere tabelle zum Import angewhlt werden  */
data2 = xlsreadsa(file, "B2", 2, "");

/*  Natrlich ist es auch mglich, Daten in eine Exceldatei
    an beliebiger Stelle hinein zuschreiben. Allerdings sollte
    hier mit Vorsicht gearbeitet werden, denn die Daten werden
    ohne Rckfrage berschrieben. */
data3 = xlsreadsa(file, "A2:B8", 3, "");
/*  Nachdem alle Namen eingelesen wurden, werden sie gleich
    sortiert wieder zurckgeschrieben. */
ret = xlswrite(sortc(data3,1), file, "C2:D8", 3, "");


/*
    Zum Anschluss erzeugen wir einen Graphen aus den gelsdenen Daten
    
*/

library pgraph;

begwind;
window(1,1,0);

ende=12;

graphset;
fonts("complex");

ylabel("Hoehe");
xlabel("Monat");

_ptitlht = .27;
_paxht = .2;
_pbartyp = { 0 9, 1 10, 3 11, 4 12, 6 13 };
_pnum = 2;

/* es werden die ersten Drei Buschtaben der Monatsnamen ermittelt*/
mylabels=zeros(ende,1);
for i (1,ende,1); mylabels[i]=strsect(month[i],1,3); endfor;
asclabel(mylabels,0);

title("Bar - Graph");
_pbarwid = 0.6;       /* overlapping */
/* es werden die Daten aus der ersten Tabelle, zweite Spalte gezeichnet*/
bar(0,data1[1:ende,2:2]);

endwind;